;;; $Id: ch6-1-3.tst,v 1.2 1998/11/13 21:01:29 leavens Exp $

(load-quietly-from-lib "run.scm")

(run-regression-tests-equal?
 `(
    ( (run "let p = proc (b) b[0] := 3
            in letarray a[2] in begin a[0] := 1; a[1] := 2; p(a); a[0] end")
       ==> 3 )
    ( (run
"letarray u[3]; v[2]
in begin
     u[0] := 5; u[1] := 6; u[2] := 4; v[0] := 3; v[1] := 8;
     let p = proc (x)
               begin
                 x[1] := 7;
                 x := v;
                 x[1] := 9
               end
     in begin
          p(u);
          list(u[0], u[1], u[2], v[0], v[1])
        end
   end")
    ==> (5 7 4 3 9) )
    ( (run
"let p = proc (x) x := 5
in let a = 3; 
       b = 4
   in begin
        p(a);
        p(b);
        +(a, b)
      end")
    ==> 7 )

    )
 )
