;; $Id: lambda-1-examples.tst,v 1.1 1998/09/25 21:40:46 leavens Exp $

(run-regression-tests-equal?
 `(
    ( (count-varrefs (make-varref 'x)) ==> 1 )
    ( (count-varrefs (make-app (make-varref 'x) (make-varref 'y))) ==> 2 )
    ( (count-varrefs (parse-lambda-1 '(x y))) ==> 2 )
    ( (count-varrefs (parse-lambda-1 '(lambda (x) x))) ==> 1 )
    ( (count-varrefs (parse-lambda-1 '(f (lambda (x) x)))) ==> 2 )

    ( (all-varrefs (parse-lambda-1 'x)) ==> (x) )
    ( (all-varrefs (parse-lambda-1 '(x y))) ==> (x y) )
    ( (all-varrefs (parse-lambda-1 '(lambda (x) y))) ==> (y) )
    ( (all-varrefs (parse-lambda-1 '(f (lambda (x) (x (f x))))))
      ==> (f x f x) )
    )
 )

