;; $Id: list-index.scm,v 1.3 1999/08/11 16:28:08 leavens Exp $

(define cs342:find
  ; TYPE: (-> (symbol (list symbol) integer) integer)
  (lambda (s los index)
    ; ENSURES: if s occurs in los, returns index plus the zero-based index
    ; of the first occurrence of s in los, otherwise returns -1
    (if (null? los) 
	-1
	(if (eq? s (car los)) 
	    index
	    (cs342:find s (cdr los) (+ 1 index))))))

(define cs342:list-index
  ; TYPE: (-> (symbol (list symbol)) integer)
  (lambda (s los)
    ; ENSURES: if s occurs in los, returns the zero-based index of
    ; the first occurrence of s in los, otherwise returns -1
    (cs342:find s los 0)))

(define list-index cs342:list-index)
(define find cs342:find)
