;;; $Id: remove-sym-exp.scm,v 1.1 1999/01/22 16:53:10 leavens Exp $

(load-quietly-from-lib "sym-exp.scm")

(define remove-sym-exp
  ;; TYPE: (-> (symbol sym-exp) (list sym-exp))
  (lambda (sym symexp)
    (if (sym-exp-symbol? symexp)
        (if (eq? sym (sym-exp->symbol symexp))
            '()
            (list symexp))
        (list (s-list->sym-exp
	       (car (remove-s-list sym (sym-exp->s-list symexp))))))))

(define remove-s-list
  ;; TYPE: (-> (symbol (list sym-exp)) (list (list sym-exp)))
  (lambda (sym slst)
    (if (null? slst)
	(list '())
	(list (append (remove-sym-exp sym (car slst))
		      (car (remove-s-list sym (cdr slst))))))))

;(define remove-s-list
;  ;; TYPE: (-> (symbol (list sym-exp)) (list (list sym-exp)))
;  (lambda (sym slst)
;    (list (apply append (map (lambda (sexp) (remove-sym-exp sym sexp))
;			     slst)))))


