;; $Id: run5-1.scm,v 1.9 1998/11/04 22:18:48 leavens Exp $
;; The run procedure from EOPL p. 144

;; Note: you have to define eval-exp before using this!

(load-quietly-from-lib "undefine-read-eval-print.scm")
(load-from-lib "char-parser-connections.scm")

;; the real thing

;;; Grammar for forms (user input):
;;;   <form> ::= <exp>
;;; These forms are a complication that result from using the same parser
;;; for many sections of this chapter.  We need to do a type conversion here
;;; to satisfy the type checker.

(define run
  ;; TYPE: (-> (<form>) Expressed-Value)
  (lambda (x)
    (eval-exp (form->exp (parse x)))))
