;; $Id: eval-print-for-oop.scm,v 1.4 1998/12/03 18:22:52 leavens Exp $

;; Version of eval-print with define primitive.

;; eval-form should call syntax-expand and pass the result to eval-exp

(define eval-print
  ; TYPE: (-> (parsed-form) void)
  (lambda (tree)
    (let ((result (eval-form tree)))
      (if (not (define? tree))
	  (cond
	   ((closure? result)
	    (display "#<closure>"))
	   ((class? result)
	    (display "#<class>"))
	   ((instance? result)
	    (display "#<instance>"))
	   (else
	    (write result)))))))
