;; $Id: eval-print-with-define.scm,v 1.13 1998/11/02 19:45:58 leavens Exp $

;; Version of eval-print with define and definearray primitives.

;; eval-form should call syntax-expand and pass the result to eval-exp

(define eval-print
  ;; TYPE: (-> (parsed-form) void)
  (lambda (tree)
    (let ((result (eval-form tree)))
      (if (not (or (define? tree)
		   (definearray? tree)))
	  (if (closure? result)
	      (display "#<closure>")
	      (write result))))))
