;;; $Id: load-from-lib.scm,v 1.12 1999/08/11 16:07:13 leavens Exp $

;;; Be sure to change the following definition!
(define *cs342:libdir* "/home/bambam/leavens/WWW/ComS342-EOPL/lib/")


(define load-from-lib-c
  ;; TYPE: (-> ((-> (string) void))
  ;;           (-> (file-name) void))
  (lambda (informer)
    (lambda (fn)
      ;; EFFECT: load the file named fn found in libdir,
      ;;         calling informer to tell anyone who cares about it.
      (let ((fullname (string-append *cs342:libdir* fn)))
	(informer (string-append "loading " fullname " ..."))
	(load fullname)))))

(define load-from-lib
  (load-from-lib-c (lambda (s) (display s) (newline))))

(define load-quietly-from-lib
  (load-from-lib-c (lambda (s) (display ""))))

(define load-quietly load)
