;;;;; $Id: type-check-syntax-helpers.scm,v 1.2 1998/09/09 03:05:29 leavens Exp $
;;; Helpers for Scheme syntax (after tc:desugaring).
;;; AUTHOR: Gary T. Leavens

(define tc:lambda-exp?   ; TYPE (-> (datum) boolean)
  (lambda (exp)
    (and (pair? exp)
	 (eq? (car exp) 'lambda))))
(define tc:lambda->args  ; TYPE: (-> (s-expression) s-expression)
  cadr)
(define tc:lambda->body  ; TYPE: (-> (s-expression) s-expression)
  caddr)
(define tc:let->bindings ; TYPE: (-> (s-expression) s-expression)
  cadr)
(define tc:let->body  ; TYPE: (-> (s-expression) s-expression)
  caddr)
(define tc:letrec->bindings ; TYPE: (-> (s-expression) s-expression)
  cadr)
(define tc:letrec->body  ; TYPE: (-> (s-expression) s-expression)
  caddr)
(define tc:appl->rator    ; TYPE: (-> (s-expression) s-expression)
  car)
(define tc:appl->rands    ; TYPE: (-> (s-expression) s-expression)
  cdr)
